// Per-vertex position, normal, color, texture coordinate information we will pass in.
attribute vec4 a_Position;
attribute vec3 a_Normal;
attribute vec4 a_Color;
attribute vec3 a_StartPoint;

uniform mat4 u_MVPMatrix;// A constant representing the combined model/view/projection matrix.

// This will be passed into the fragment shader.
varying vec3 v_Position;
varying vec3 v_Normal;
varying vec4 v_Color;
varying vec3 v_StartPoint;
varying vec4 v_AllColor;

uniform vec2 u_ScreenSize;
uniform float u_Time;
uniform vec3 u_IntersectionPoint;
uniform vec4 u_Color;

varying vec2 v_ScreenSize;
varying float v_Time;
varying vec3 v_IntersectionPoint;

// The entry point for our vertex shader.
void main() {

    // // Transform the vertex into eye space.
//     v_Position = vec3(u_MVPMatrix * a_Position);
    v_Position =  a_Position.xyz;

    // Transform the normal's orientation into eye space.
    v_Normal = a_Normal;
//    v_Normal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));

    v_StartPoint = a_StartPoint;

    v_Color = a_Color;
    v_AllColor = u_Color;

    v_Time = u_Time;
    v_ScreenSize = u_ScreenSize;
    v_IntersectionPoint = u_IntersectionPoint;

    // gl_Position is a special variable used to store the final position.
    // Multiply the vertex by the matrix to get the final point in normalized screen coordinates.
    gl_Position = u_MVPMatrix * a_Position;

}