// Per-vertex position, normal, color, texture coordinate information we will pass in.
attribute vec4 a_Position;
attribute vec3 a_Normal;
attribute vec4 a_Color;
attribute vec2 a_TexCoordinate;

uniform mat4 u_MVPMatrix;// A constant representing the combined model/view/projection matrix.
uniform mat4 u_MVMatrix;// A constant representing the combined model/view matrix.

// This will be passed into the fragment shader.
varying vec3 v_Position;
varying vec3 v_Normal;
varying vec4 v_Color;
varying vec2 v_TexCoordinate;

uniform vec3 u_LightPosition;
uniform vec3 u_LightDirection;

uniform vec2 u_ScreenSize;
uniform float u_Time;
uniform vec2 u_TouchPoint;
uniform bool u_LightIsOn;

varying vec2 v_ScreenSize;
varying float v_Time;
varying vec2 v_TouchPoint;

varying mat4 v_MVMatrix;

// The entry point for our vertex shader.
void main() {

    // // Transform the vertex into eye space.
    // v_Position = vec3(u_MVMatrix * a_Position);
    v_Position =  a_Position.xyz;

    // Transform the normal's orientation into eye space.
    v_Normal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));

    // Pass through the texture coordinate.
    v_TexCoordinate = a_TexCoordinate;
    v_Color = a_Color;

    v_Time = u_Time;
    v_ScreenSize = u_ScreenSize;
    v_TouchPoint = u_TouchPoint;
    v_MVMatrix = u_MVMatrix;

    //    gl_PointSize = 16.0;

    //    // Transform the vertex into eye space.
    //    vec3 modelViewVertex = vec3(u_MVMatrix * a_Position);
    //    // Transform the normal's orientation into eye space.
    //    vec3 modelViewNormal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));
    //    vec3 lightPosition = vec3(u_MVMatrix[3][0], u_MVMatrix[3][1], u_MVMatrix[3][2]);
//
//    v_LightPosition = vec3(u_MVMatrix[3][0], u_MVMatrix[3][1], u_MVMatrix[3][2]);
//    v_LightDirection = vec3(u_MVMatrix[0][2], u_MVMatrix[1][2], u_MVMatrix[2][2]);

    //    // Will be used for attenuation.
    //    float distanceTo = length(v_LightPosition - modelViewVertex);
    //    // Get a lighting direction vector from the light to the vertex.
    //    //       vec3 lightVector = normalize(LIGHT_POS - modelViewVertex);
    //    vec3 lightVector = modelViewNormal;
    //    // Calculate the dot product of the light vector and vertex normal. If the normal and light vector are
    //    // pointing in the same direction then it will get max illumination.
    //    float diffuse = max(dot(modelViewNormal, lightVector), 0.4);
    //
    //    // Add attenuation.
    //    diffuse = diffuse * (1.0 / (1.0 + (0.25 * distanceTo * distanceTo)));
    //
    //    // Add ambient lighting
    //    diffuse = diffuse + 0.1;

    // Multiply the color by the illumination level. It will be interpolated across the triangle.
    //        v_Color = a_Color;
    //    v_Color = a_Color * diffuse;

    // gl_Position is a special variable used to store the final position.
    // Multiply the vertex by the matrix to get the final point in normalized screen coordinates.
    gl_Position = u_MVPMatrix * a_Position;

}
//
//uniform mat4 u_MVPMatrix;           // A constant representing the combined model/view/projection matrix.
//uniform mat4 u_MVMatrix;            // A constant representing the combined model/view matrix.
//uniform vec3 u_LightPos;            // The position of the light in eye space.
//
//attribute vec4 a_Position;          // Per-vertex position information we will pass in.
//attribute vec4 a_Color;             // Per-vertex color information we will pass in.
//attribute vec3 a_Normal;            // Per-vertex normal information we will pass in.
//
//varying vec4 v_Color;               // This will be passed into the fragment shader.
//
//void main()                         // The entry point for our vertex shader.
//{
//// Transform the vertex into eye space.
//   vec3 modelViewVertex = vec3(u_MVMatrix * a_Position);
//// Transform the normal's orientation into eye space.
//   vec3 modelViewNormal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));
//// Will be used for attenuation.
//   float distanceTo = length(u_LightPos - modelViewVertex);
//// Get a lighting direction vector from the light to the vertex.
//   vec3 lightVector = normalize(u_LightPos - modelViewVertex);
//// Calculate the dot product of the light vector and vertex normal. If the normal and light vector are
//// pointing in the same direction then it will get max illumination.
//   float diffuse = max(dot(modelViewNormal, lightVector), 0.1);
//// Attenuate the light based on distanceTo.
//   diffuse = diffuse * (1.0 / (1.0 + (0.25 * distanceTo * distanceTo)));
//// Multiply the color by the illumination level. It will be interpolated across the triangle.
//   v_Color = a_Color * diffuse;
//// gl_Position is a special variable used to store the final position.
//// Multiply the vertex by the matrix to get the final point in normalized screen coordinates.
//   gl_Position = u_MVPMatrix * a_Position;
//}